
import java.awt.*;

final class EfloyCheck extends Frame {
    Button cancel;
    Button ok;
    Button reset;
	Button defaults;
	Button leader;
    Efloy floys[];
    TextField nf;
    TextField acc;
    TextField acctomid;
	TextField revdist;
    TextField maxspeed;
    TextField bouncespeed;
    TextField sleep;
    TextField v0;
    TextField kick;
	TextField numnb;
	TextField color;
	TextField floynum;
	Label label;
	TextField chromo;
	String newpars;
	String newfixs;
	String newenvs;

    
    public EfloyCheck (Efloy f[]) {
        super("Floy Check Panel");
        floys = f;
		float fi = 0f;
        
        cancel = new Button("Zrui");
        ok = new Button("OK");
        reset = new Button("Reset");
		defaults = new Button("Defaultn");
		leader = new Button("Vodca");
        Panel okPanel = new Panel();
        okPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
        okPanel.add(cancel);
        okPanel.add(ok);
        okPanel.add(reset);
		okPanel.add(defaults);
        this.add("South", okPanel);
        
		label = new Label("Vlastnosti (Globlne / Individulne)");
        Panel titlePanel = new Panel();
        titlePanel.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
        titlePanel.add(label);
        this.add("North", titlePanel);

        nf = new TextField();
        floynum = new TextField();
		color = new TextField();
        acc = new TextField();
        acctomid = new TextField();
        revdist = new TextField();
        maxspeed = new TextField();
        bouncespeed = new TextField();
        sleep = new TextField();
		kick = new TextField();
		numnb = new TextField();
		chromo = new TextField(20);
		
		reset(1);

        Panel controlPanel = new Panel();
        controlPanel.setLayout(new GridLayout(12, 2, 0, 0)); 
        controlPanel.add(new Label("Poet Floyov:"));
		controlPanel.add(nf);
        controlPanel.add(new Label("asov medzera:"));         
		controlPanel.add(sleep);
        controlPanel.add(new Label("Koeficient slobodnej vle:"));      
		controlPanel.add(kick);
		controlPanel.add(new Label("Poet susedov:"));      
		controlPanel.add(numnb);
		

		controlPanel.add(new Label("-----------",Label.CENTER));
		controlPanel.add(new Label("-----------",Label.CENTER));

        controlPanel.add(new Label("Aplikova na Floya .:"));
		controlPanel.add(floynum);
        controlPanel.add(new Label("Farba Floya:"));
		controlPanel.add(color);
        controlPanel.add(new Label("Zrchlenie:"));      
		controlPanel.add(acc);
        controlPanel.add(new Label("Lipnutie:"));     
		controlPanel.add(acctomid);
        controlPanel.add(new Label("Kolzna vzdialenos:"));    
		controlPanel.add(revdist);
        controlPanel.add(new Label("Max. rchlos:"));	
		controlPanel.add(maxspeed);
        controlPanel.add(new Label("Chromzm:"));       
		controlPanel.add(chromo);
		
		

        Panel alignPanel = new Panel();
        alignPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
        alignPanel.add("Center", controlPanel);
        this.add("Center", alignPanel);
        
        this.pack();
        this.show();
        }
    

	private void reset(int num) {

		if (num == 1) {
	        nf.setText(""+Efloys.NF);
			floynum.setText("1");
		    acc.setText(""+Efloys.ACC);
			acctomid.setText(""+Efloys.ACCTOMID);
	        revdist.setText(""+Efloys.REVDIST);
		    maxspeed.setText(""+Efloys.MAXSPEED);
			bouncespeed.setText(""+Efloys.BOUNCESPEED);
	        sleep.setText(""+Efloys.SLEEP);
		    color.setText("Black");
			kick.setText(""+Efloys.KICK);
			numnb.setText(""+Efloys.NUMNB);
			chromo.setText("");
		}
		else {
	        nf.setText("10");
			floynum.setText("1");
		    acc.setText("0.3");
			acctomid.setText("0.1");
	        revdist.setText("200");
		    maxspeed.setText("5");
			bouncespeed.setText("0.8");
	        sleep.setText("10");
		    color.setText("Black");
			kick.setText("0.05");
			numnb.setText("2");
			chromo.setText("");
		}


	}




    public boolean action(Event e, Object arg) {

		String fnum;
		int num;

        if (e.target == reset) {
			reset(1);
			}
        if (e.target == defaults) {
            Efloys.reset();
			reset(1);
			}

        if (e.target == ok) {
			fnum = readString(floynum, "Vetci");
			if (fnum.equals("Vetci")) {
				Efloys.ResetPopulation = true;
	            Efloys.NF = readInt(nf, Efloys.NF);
				Efloys.ACC = readFloat(acc, Efloys.ACC);
				Efloys.ACCTOMID = readFloat(acctomid, Efloys.ACCTOMID);
				Efloys.REVDIST = readInt(revdist, Efloys.REVDIST);
				Efloys.MAXSPEED = readFloat(maxspeed, Efloys.MAXSPEED);
				Efloys.BOUNCESPEED = readFloat(bouncespeed, Efloys.BOUNCESPEED);
				Efloys.SLEEP = readLong(sleep, Efloys.SLEEP);
				Efloys.COLOR = readString(color, Efloys.COLOR);
				Efloys.KICK = readFloat(kick, Efloys.KICK);
				Efloys.NUMNB = readInt(numnb, Efloys.NUMNB);

			}
			else {
				Efloys.ResetPopulation = false;
				if (fnum.equals("Votrelec"))
					num = 0;
				else
					num = Integer.parseInt(fnum);
			}

            this.hide();
            this.dispose();
			Efloys.First = true;
            return true;
            }

        if (e.target == cancel) {
			Efloys.First = true;
            this.hide();
            this.dispose();
            return true;
            }
		

		if (e.target == floynum) {

			fnum = readString(floynum, "Vetci");
			if (!fnum.equals("Vetci")) {
				if (fnum.equals("Votrelec"))
					num = 0;
				else
					num = Integer.parseInt(fnum);

				acc.setText(""+floys[num].ApproachAcceleration);
				acctomid.setText(""+floys[num].CenterAcceleration);
				revdist.setText(""+floys[num].CollisionDistance);
				maxspeed.setText(""+floys[num].MaxSpeed);
				bouncespeed.setText(""+floys[num].BounceSpeed);
				color.setText(""+floys[num].GetColorName());
				numnb.setText(""+floys[num].NumberOfNeighbors);
				chromo.setText(floys[num].chrom);
			}

            return true;

		}
		

        else
            return false;
        }
    

    private String readString(TextField c, String d) {
        String n;
        
        try {
            n = c.getText();
            }
        catch (Exception e) {
            n = d;
            }
        
        return n;
        }


    private int readInt(TextField c, int d) {
        int n;
        
        try {
            n = Integer.parseInt(c.getText());
            }
        catch (NumberFormatException e) {
            n = d;
            }
        
        return n;
        }

    private long readLong(TextField c, long d) {
        long n;
        
        try {
			n = Long.parseLong(c.getText().trim());
            }
        catch (NumberFormatException e) {
            n = d;
            }
        
        return n;
        }
		
    private float readFloat(TextField c, float d) {
        float n;
        
        try {
            n = Float.valueOf(c.getText()).floatValue();
            }
        catch (NumberFormatException e) {
            n = d;
            }
        
        return n;
        }



    private Color ReadColor(TextField c, String d) {
        String n;
		Color col;
        
        try {
            n = c.getText();
            }
        catch (Exception e) {
            n = d;
            }
        
		col = GetColorByString(n);
        return col;

        }

	public Color GetColorByString(String c) {

		Color col;

		if (c.equals("ierna")) col = Color.black;
		else if (c.equals("Modr")) col = Color.blue;
		else if (c.equals("Zelenomodr")) col = Color.cyan;
		else if (c.equals("Tmavoed")) col = Color.darkGray;
		else if (c.equals("ed")) col = Color.gray;
		else if (c.equals("Zelen")) col = Color.green;
		else if (c.equals("Svetloed")) col = Color.lightGray;
		else if (c.equals("Oranov")) col = Color.orange;
		else if (c.equals("Ruov")) col = Color.pink;
		else if (c.equals("erven")) col = Color.red;
		else if (c.equals("Biela")) col = Color.white;
		else if (c.equals("lt")) col = Color.yellow;
		else col = Color.black;

		return col;

	}


}
