
import java.awt.*;
import java.util.*;


final class EfloyInfo extends Frame {

    Button primary;
    Button secondary;
    Button environ;
	Button chromo;
	Button fitness;
	Button history;
	Button quitit;
	
	Panel okPanel;
	Panel TitlePanel;
	Panel TablePanel;
	Panel PrimaryTable;
	Panel SecondaryTable;
	Panel EnvironTable;
	Panel ChromoTable;
	Panel FitnessTable;
	Panel HistoryTable;

	Label TitleLabel;
	CardLayout cardLayout;
	EfloyScrollPanel sp;

    Efloy floys[];
    
    public EfloyInfo (Efloy f[]) {
        super("Informcie o populcii Floyov");
        floys = f;
		float fi = 0f;
		int i,j;
        
		setBackground(Color.lightGray);
		setForeground(Color.black);

        primary = new Button("Hlavn");
        secondary = new Button("Vedajie");
        environ = new Button("Prostredie");
		chromo = new Button("Chromozmi");
		fitness = new Button("Fitness(Vhodnos)");
		history = new Button("Histria");
		quitit = new Button("Koniec");

        okPanel = new Panel();
        okPanel.setLayout(new FlowLayout(FlowLayout.CENTER, 5, 5));
        okPanel.add(primary);
        okPanel.add(secondary);
        okPanel.add(environ);
		okPanel.add(fitness);
		okPanel.add(history);
		okPanel.add(quitit);
        this.add("South", okPanel);
		Font ButtonFont = new Font("TimesRoman",Font.PLAIN,12);
		okPanel.setFont(ButtonFont);

        TitlePanel = new Panel();
        TitlePanel.setLayout(new FlowLayout(FlowLayout.CENTER, 15, 15));
		TitleLabel = new Label("Hlavn vlastnosti");
		TitlePanel.add(TitleLabel);
		this.add("North",TitlePanel);
		Font TitleFont = new Font("TimesRoman",Font.BOLD,12);
		TitlePanel.setFont(TitleFont);
		TitlePanel.setForeground(Color.blue);

        TablePanel = new Panel();
		cardLayout = new CardLayout(0,0);
		TablePanel.setLayout(cardLayout);

		PrimaryTable = new Panel();
		PrimaryTable.setLayout(new GridLayout(0,10));
		PrimaryTable.setFont(new Font("TimesRoman", Font.PLAIN, 10));
		FillPrimary(PrimaryTable);
		sp = new EfloyScrollPanel(PrimaryTable, "V");
		TablePanel.add("Primary",sp);

		SecondaryTable = new Panel();
		SecondaryTable.setLayout(new GridLayout(0,7));
		FillSecondary(SecondaryTable);
		sp = new EfloyScrollPanel(SecondaryTable, "V");
		TablePanel.add("Secondary",sp);


		EnvironTable = new Panel();
		EnvironTable.setLayout(new GridLayout(0,2));
		FillEnviron(EnvironTable);
		sp = new EfloyScrollPanel(EnvironTable, "V");
		TablePanel.add("Environ",sp);



		FitnessTable = new Panel();
		FitnessTable.setLayout(new GridLayout(0,5));
		FillFitness(FitnessTable);
		sp = new EfloyScrollPanel(FitnessTable, "V");
		TablePanel.add("Fitness",sp);


		HistoryTable = new Panel();
		HistoryTable.setLayout(new GridLayout(0,10));
		FillHistory(HistoryTable);
		sp = new EfloyScrollPanel(HistoryTable, "V");
		TablePanel.add("History",sp);


		this.add("Center",TablePanel);

		this.pack();

	}


	private void FillPrimary(Panel panel) {

		int i;
		SortFloys();

		panel.add(new Label("slo"));
		panel.add(new Label("ID"));
		panel.add(new Label("Max.rchlos"));
		panel.add(new Label("Odrazov rch."));
		panel.add(new Label("Zrchlenie"));
		panel.add(new Label("Lipnutie k str."));
		panel.add(new Label("Kolzna vzdial."));
		panel.add(new Label("Farba"));
		panel.add(new Label("Fitness"));
		panel.add(new Label("Energia"));

		for (i=0;i < floys.length;i++) {
			panel.add(new Label(""+i));
			panel.add(new Label(""+floys[i].id));
			panel.add(new Label(""+floys[i].MaxSpeed));
			panel.add(new Label(""+floys[i].BounceSpeed));
			panel.add(new Label(""+floys[i].ApproachAcceleration));
			panel.add(new Label(""+floys[i].CenterAcceleration));
			panel.add(new Label(""+floys[i].CollisionDistance));
			panel.add(new Label(""+floys[i].GetColorName()));
			panel.add(new Label(""+floys[i].fitness));
			panel.add(new Label(""+floys[i].energy));
		}

	}


	private void FillSecondary(Panel panel) {

		int i;

		panel.add(new Label("ID"));
		panel.add(new Label("Vzdialenos"));
		panel.add(new Label("Vzdialenos"));
		panel.add(new Label("Vzdialenos"));
		panel.add(new Label("Kolzia"));
		panel.add(new Label("Kolzia"));
		panel.add(new Label("Kolzia"));

		panel.add(new Label(" "));
		panel.add(new Label("Brat"));
		panel.add(new Label("Votrelec"));
		panel.add(new Label("Miestny"));
		panel.add(new Label("Brat"));
		panel.add(new Label("Votrelec"));
		panel.add(new Label("Miestny"));

		for (i=0;i < floys.length;i++) {
			panel.add(new Label(""+floys[i].id));
			panel.add(new Label(""+floys[i].DistBrotherFactor));
			panel.add(new Label(""+floys[i].DistStrangerFactor));
			panel.add(new Label(""+floys[i].DistLocalFactor));
			panel.add(new Label(""+floys[i].CollisionBrotherFactor));
			panel.add(new Label(""+floys[i].CollisionStrangerFactor));
			panel.add(new Label(""+floys[i].CollisionLocalFactor));
		}

	}



	private void FillEnviron(Panel panel) {


		panel.add(new Label("Vekos populcie"));
		panel.add(new Label(""+floys[0].PopulationSize));

		panel.add(new Label("Poet susedov"));
		panel.add(new Label(""+floys[0].NumberOfNeighbors));

		panel.add(new Label("Koeficient krenia"));
		panel.add(new Label(""+floys[0].CrossoverFactor));

		panel.add(new Label("Koeficient mutcie"));
		panel.add(new Label(""+floys[0].MutationFactor));

		panel.add(new Label("Koeficient vhy energie"));
		panel.add(new Label(""+floys[0].EnergyFactor));

		panel.add(new Label("Koeficient vhy bezpeia"));
		panel.add(new Label(""+floys[0].SafetyFactor));

		panel.add(new Label("Koeficient vhy spoluprce"));
		panel.add(new Label(""+floys[0].CooperationFactor));

		panel.add(new Label("Dka ivota"));
		panel.add(new Label(""+floys[0].LifeSpan));

		panel.add(new Label("Koeficient slobodnej vle"));
		panel.add(new Label(""+floys[0].FreeWillFactor));

		panel.add(new Label("Max. podiel energie"));
		panel.add(new Label(""+floys[0].MaxEnergyDose));

		panel.add(new Label("Max. podiel bezpeia"));
		panel.add(new Label(""+floys[0].MaxSafetyDose));

		panel.add(new Label("Max. podiel spoluprce"));
		panel.add(new Label(""+floys[0].MaxCooperationDose));

		panel.add(new Label("Percento preitia"));
		panel.add(new Label(""+floys[0].SurviversFactor));

		panel.add(new Label("Vlastnos spomalenia pohybu"));
		panel.add(new Label(""+floys[0].sleep));


	}


	private void FillChromo(Panel panel) {

		int i;

		panel.add(new Label("ID"));
		panel.add(new Label("Premenliv"));
		panel.add(new Label("Pevn"));
		panel.add(new Label("Tkajce sa prostredia"));
		panel.add(new Label("Farba"));

		for (i=0;i < floys.length;i++) {
			panel.add(new Label(""+floys[i].id));
			panel.add(new Label(""+floys[i].chrom));
			panel.add(new Label(""+floys[i].fixed));
			panel.add(new Label(""+floys[i].environ));
			panel.add(new Label(""+floys[i].GetColorName()));
		}

	}


	private void FillFitness(Panel panel) {

		int i;

		panel.add(new Label("ID"));
		panel.add(new Label("Energia"));
		panel.add(new Label("Bezpeie"));
		panel.add(new Label("Spoluprca"));
		panel.add(new Label("Fitness(Vhodnos)"));

		for (i=0;i < floys.length;i++) {
			panel.add(new Label(""+floys[i].id));
			panel.add(new Label(""+floys[i].energy));
			panel.add(new Label(""+floys[i].safety));
			panel.add(new Label(""+floys[i].cooperation));
			panel.add(new Label(""+floys[i].fitness));
		}

	}


	private void FillHistory(Panel panel) {

		int i, j, k, n, m;
		EfloyGeneration g = new EfloyGeneration();

		panel.add(new Label("."));
		panel.add(new Label("Kroky "));
		panel.add(new Label("Rchlos"));
		panel.add(new Label("Zrch."));
		panel.add(new Label("VMM"));
		panel.add(new Label("VMV"));
		panel.add(new Label("VVM"));
		panel.add(new Label("KMM"));
		panel.add(new Label("KMV"));
		panel.add(new Label("KVM"));

		n = Efloys.HistoryData.size();
		m = (int) (n/24+1);
		Enumeration  e  =  Efloys.HistoryData.elements();

		k=0;
		for (i=0;i<n;i++) {
			
			try {
				g = ((EfloyGeneration) e.nextElement());
				k++;
				panel.add(new Label(""+g.num));
				panel.add(new Label(""+g.steps));
				panel.add(new Label(""+double2String(g.speedavg,2)));
				panel.add(new Label(""+double2String(g.accavg, 2)));
				panel.add(new Label(""+double2String(g.dllavg, 2)));
				panel.add(new Label(""+double2String(g.dlsavg, 2)));
				panel.add(new Label(""+double2String(g.dslavg, 2)));
				panel.add(new Label(""+double2String(g.cllavg, 2)));
				panel.add(new Label(""+double2String(g.clsavg, 2)));
				panel.add(new Label(""+double2String(g.cslavg, 2)));
			}
			catch (Exception ex) {
			}
			
		}
		
		
		if (k<18) {
			for (i=k+1;i<17;i++)
				for (j=0;j<7;j++)
				   panel.add(new Label(" "));
		}
		

	}



public static String double2String( double value, int sigFigs ) {
	

		double factor = Math.pow( 10.0, sigFigs );

		return new String( ( (double)Math.round( value * factor ) / factor ) + "" );
	}


	void SortFloys() {

		int i,j;
		boolean swap;
		int e;
		Efloy etemp;

		for (i=0;i < floys.length-1;i++) {
			swap = false;
			for (j=floys.length-2;j>=i;j--) {
				e = floys[j].fitness - floys[j+1].fitness;
				if (e < 0) {
					etemp = floys[j];
					floys[j] = floys[j+1];
					floys[j+1] = etemp;
					swap = true;
				}
			}
			if (swap == false) {
				break;
			}
		}

	}



	public boolean mouseExit(Event evt, int x, int y) {

		Efloys.appcontext.showStatus("");
		return true;

	}



    public boolean action(Event e, Object arg) {


		int i, j;

        if (e.target == primary) {
			TitleLabel.setText("Hlavn vlastnosti");
			cardLayout.show(TablePanel,"Primary");
		}
        if (e.target == secondary) {
			TitleLabel.setText("Vedajie vlastnosti");
			cardLayout.show(TablePanel,"Secondary");
		}
        if (e.target == environ) {
			TitleLabel.setText("Charakteristiky prostredia");
			cardLayout.show(TablePanel,"Environ");
		}
        if (e.target == chromo) {
			TitleLabel.setText("Chromozmy");
			cardLayout.show(TablePanel,"Chromo");
		}
        if (e.target == fitness) {
			TitleLabel.setText("Tabuka fitness");
			cardLayout.show(TablePanel,"Fitness");
		}
        if (e.target == history) {
			TitleLabel.setText("Histria");
			cardLayout.show(TablePanel,"History");
		}


        if (e.target == quitit) {
            this.hide();
            this.dispose();
            return true;
            }
		
		TitleLabel.resize(TitleLabel.preferredSize());
        return true;

	}


	public boolean handleEvent(Event ev) {

	    if (ev.id == Event.WINDOW_DESTROY) {
            this.hide();
            this.dispose();
            return true;
		}
		else
			return super.handleEvent(ev);

	} 



}
    