
import java.awt.*;
import java.util.Date;


public class EfloyLog extends Frame
{
  TextArea ta;
  Date StartDate, EndDate;


  EfloyLog(String title)
  {
    super(title);

    ta = new TextArea(50,100);
    ta.setText("");
    setLayout(new BorderLayout());
    add("Center", ta);

    this.pack();
  }


  public boolean handleEvent(Event ev)
  {
    if (ev.id == Event.WINDOW_DESTROY)
    {
      hide();
      return true;
    }
    else
      return super.handleEvent(ev);
  } 


  public void start()
  {
	StartDate = new Date();
	if (Efloys.InLog)
	    ta.appendText("Session zaala: " + StartDate.toString()+"\n\n");
  }


  public void end()
  {
	EndDate = new Date();
	if (Efloys.InLog)
	    ta.appendText("Koniec: " + EndDate.toString());
  }


  public void showMsg(String msg)
  {
	if (Efloys.InLog)
		ta.appendText(msg + '\n');
  }


  public void showMsg(Object obj)
  {
	if (Efloys.InLog)
	    ta.appendText(String.valueOf(obj) + '\n');
  }


  public void showMsg(int n)
  {
	if (Efloys.InLog)
	    ta.appendText(String.valueOf(n) + '\n');
  }


  public void clear()
  {
	if (Efloys.InLog)
		ta.setText("");
  }


  public void clear(String msg)
  {
	if (Efloys.InLog)
	    ta.setText(msg);
  }
}
