

class EfloyParam {

	float min;
	float max;
	float step;
	float value;
	int nsteps;
	String name;
	boolean mutatable;

	public EfloyParam(float mn, float mx, float st, float vl, String nm, boolean mt) {

		min = mn;
		max = mx;
		step = st;
		name = nm;
		value = vl;
		mutatable = mt;

		nsteps = (int) ((mx-mn)/step);


	}

	public EfloyParam (float mn, float mx, int ns, float vl, String nm, boolean mt) {

		min = mn;
		max = mx;
		nsteps = ns;
		name = nm;
		value = vl;
		mutatable = mt;

		step = (float) ((mx-mn)/nsteps);

	}

	char EncodeValue() {

		int n = (int) ((value - min)/step);
		char k = (char) (65+n);
		return k;

	}

	float DecodeValue(char kar) {

		int n;
		float k;

		try {
			n = (int) (kar - 65);
			k = min + n*step;
			return k;
		}
		catch (Exception e) {
			return 0f;
		}

	}

}

