/*
 * Title: Vyvjajci sa Floyi
 *
 * Description:
 *
 * Author: Peter Palkovi 2006
 * 
 */


import java.applet.*;
import java.awt.*;
import java.net.*;
import javax.swing.*;
import javax.swing.border.TitledBorder;
import javax.swing.border.Border;
import javax.swing.event.*;
import java.awt.event.*;
import java.util.Vector;
import java.util.Date;


class EfloyCanvas extends Canvas
{
	Image image;
	Color color;
	boolean first;
	boolean reset;
	Image OffImg;
	Graphics OffGra;


	public EfloyCanvas(Image img)	{

		super();
 		image = img;
		color = Color.white;
		setBackground(Color.white);
		setForeground(Color.black);
		first = true;
		reset = false;

	}

	public EfloyCanvas(Color c)	{

		super();
 		image = null;
		setBackground(Color.white);
		setForeground(Color.black);
		color = c;
		first = true;
		reset = false;

	}

	public void Clear() {

		reset = true;
		repaint();

	}


	public void paint(Graphics g) {

		int i;
		Efloy Efloy;


		if (Efloys.Efloys != null) {
			for (i=0;i<Efloys.Efloys.length;i++)
	 		{
				try {
					Efloy = Efloys.Efloys[i];
					Efloy.GetNeighbors();
	 				Efloy.Process();
					Efloy.Draw(g);
				}
				catch (Exception e) {
				}
	 		}
		}

	}


	public void xpaint(Graphics g) {

		int i;
		Efloy Efloy;

		OffImg = createImage(size().width, size().height);

		try {
		    OffGra = OffImg.getGraphics();
		}
	    catch (Exception e) {
			Efloys.appcontext.showStatus("After OffImg e= "+e.toString());
		}


		OffGra.setColor(getBackground());
		OffGra.fillRect(0,0,size().width,size().height);

		for (i=0;i<Efloys.Efloys.length;i++)
	 	{
			Efloy = Efloys.Efloys[i];
			Efloy.GetNeighbors();
	 		Efloy.Process();
			Efloy.Draw(OffGra);
	 	}

		g.drawImage(OffImg, 0, 0, this);
	}


	Graphics GetGra() {

		return this.getGraphics();
	}
}

public class Efloys extends Applet implements Runnable {

	Thread runner;
	EfloyCanvas canvas;
	EfloyCommand fcommand;
	EfloyInfo finfo;
	EfloyPredefined fpredefined;
	static Efloy[] Efloys;
	static Efloy[] NewFloys;

    JLabel lbPocet = new JLabel();
	static JSlider sldPocet = new JSlider();
    JLabel lbRychlost = new JLabel();
	static JSlider sldRychlost = new JSlider();

    Border border1 = BorderFactory.createEtchedBorder(Color.white,new Color(156, 156, 158));
    Border border2 = new TitledBorder(border1, "Model prostredia");
    JPanel pnlModel = new JPanel();
    ButtonGroup rbtnEnviroment = new ButtonGroup();
    JRadioButton rbtnEnviromentToroid = new JRadioButton("Toroid");
    JRadioButton rbtnEnviromentBounded = new JRadioButton("Ohranien");


    Border border3 = BorderFactory.createEtchedBorder(Color.white,new Color(156, 156, 158));
    Border border4 = new TitledBorder(border3, "Votrelec");
    JPanel pnlVotrelec = new JPanel();
    TitledBorder titledBorder3 = new TitledBorder("");
	JButton Stranger = new JButton();
	JButton Odobrat = new JButton();

	JButton Start = new JButton();
	JButton Pause = new JButton();	
	JButton Info = new JButton();	
	JButton Control = new JButton();
	JButton Scramble = new JButton();	
	JButton Breed = new JButton();	
	static JButton Evolution = new JButton();

	JButton Log = new JButton();
	JButton Predefined = new JButton();
	JButton Numbers = new JButton();
	JButton Ranges = new JButton();

	Graphics gra;
	Panel center;
	Panel center1;
	static Label MainTitle;
	URL MainPage;
	static EfloyParam params[];
	static EfloyParam fixpars[];
	static EfloyParam envpars[];
	Font ButtonFont;
	Date StartDate;

	int wa,ha,wc,hc;
	int CurrentBehavior;
	int CurrentNum;
	long CurrentStep;
	long CurrentTotalStep;
	static long CurrentGeneration;
	long CurrentRandom;
	long SumFitness;
	boolean running;
	static boolean First;
	static boolean ResetPopulation = true;
	static boolean NewGeneration = false;
	static boolean InEvolution = false;
	static boolean DrawNumbers = false;
	static boolean WithSound = true;
	static boolean InLog = true;
	static boolean LimitedRanges = false;

	static EfloyGeneration FloyGen;
	static Vector HistoryData;

	static int NF;
	static int REVDIST;
	static float ACC;
	static float ACCTOMID;	
	static float MAXSPEED;
	static float BOUNCESPEED;
	static float V0;
	static float KICK;
	static long SLEEP;
	static int MARGIN;
	static int NUMNB;
	static int TYPE;
	static String COLOR;


    static Image picture;
    static AppletContext appcontext;
	static EfloyLog deb;
	static EfloyLog helpwin;
	static EfloyLog rulewin;
	static Dimension ScreenSize;


	public void init() {
		int i;
		Float temp;
		String s;

		ButtonFont = new Font("TimesRoman",Font.PLAIN,12);

	    deb = new EfloyLog("Log okno");
		deb.hide();
        deb.showMsg("");
	    deb.reshape(50,40,540,380);
		deb.start();

		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		ScreenSize = d;
		int w = d.width;
		int h = d.height;


		setLayout(new BorderLayout(5,20));
		setBackground(Color.lightGray);
		Panel bot = new Panel();



		Start.setPreferredSize(new Dimension(150, 25));
        Start.setText("Retart");
        Start.setBounds(new Rectangle(25, 315, 150, 25));
        Start.addActionListener(new StartAction(this));						

        lbRychlost.setText("Rchlos : 80%");
        lbRychlost.setBounds(new Rectangle(17, 10, 100, 15));

		sldRychlost.setBackground(Color.lightGray);
        sldRychlost.setPreferredSize(new Dimension(180, 20));
        sldRychlost.setBounds(new Rectangle(10, 30, 180, 20));
        sldRychlost.addChangeListener(new RychlostAction(this));			
        sldRychlost.setMaximum(100);										
        sldRychlost.setMinimum(1);
        sldRychlost.setValue(80);



        lbPocet.setText("Poet jedincov: 10");
        lbPocet.setBounds(new Rectangle(18, 60, 110, 15));
        sldPocet.setMinimum(2);													
        sldPocet.setMaximum(50);
        sldPocet.setValue(10);

		sldPocet.setBackground(Color.lightGray);
        sldPocet.setPreferredSize(new Dimension(180, 20));
        sldPocet.setBounds(new Rectangle(10, 30, 180, 20));
        sldPocet.addChangeListener(new PocetAction(this));



		Scramble.setPreferredSize(new Dimension(150, 25));
        Scramble.setText("Zamiea");
        Scramble.setBounds(new Rectangle(25, 315, 150, 25));
        Scramble.addActionListener(new ScrambleAction(this));						


		Odobrat.setPreferredSize(new Dimension(150, 25));
        Odobrat.setText("Odobra");
        Odobrat.setBounds(new Rectangle(25, 315, 150, 25));
        Odobrat.addActionListener(new OdobratAction(this));

		Stranger.setPreferredSize(new Dimension(150, 25));
        Stranger.setText("Prida");
        Stranger.setBounds(new Rectangle(25, 315, 150, 25));
        Stranger.addActionListener(new StrangerAction(this));						



		Breed.setPreferredSize(new Dimension(150, 25));
        Breed.setText("Nov genercia");
        Breed.setBounds(new Rectangle(25, 315, 150, 25));
        Breed.addActionListener(new BreedAction(this));				



		Evolution.setPreferredSize(new Dimension(150, 25));
        Evolution.setText("tart evolcie");
        Evolution.setBounds(new Rectangle(25, 315, 150, 25));
        Evolution.addActionListener(new EvolutionAction(this));			



		Numbers.setPreferredSize(new Dimension(150, 25));
        Numbers.setText("Uk sla");
        Numbers.setBounds(new Rectangle(25, 315, 150, 25));
        Numbers.addActionListener(new NumbersAction(this));



		Pause.setPreferredSize(new Dimension(150, 25));
        Pause.setText("Pauza");
        Pause.setBounds(new Rectangle(25, 315, 150, 25));
        Pause.addActionListener(new PauseAction(this));					



		Ranges.setPreferredSize(new Dimension(150, 25));
        Ranges.setText("Limitovan rozsah");
        Ranges.setBounds(new Rectangle(25, 315, 150, 25));
        Ranges.addActionListener(new RangesAction(this));				
		



		Log.setPreferredSize(new Dimension(150, 25));
        Log.setText("Uk Log");
        Log.setBounds(new Rectangle(25, 315, 150, 25));
        Log.addActionListener(new LogAction(this));					
	
	
		Predefined.setPreferredSize(new Dimension(150, 25));
        Predefined.setText("Vopred definovne");
        Predefined.setBounds(new Rectangle(25, 315, 150, 25));
        Predefined.addActionListener(new PredefinedAction(this));		


		Control.setPreferredSize(new Dimension(150, 25));
        Control.setText("Vlastnosti");
        Control.setBounds(new Rectangle(25, 315, 150, 25));
        Control.addActionListener(new ControlAction(this));					


		Info.setPreferredSize(new Dimension(150, 25));
        Info.setText("Uk info");
        Info.setBounds(new Rectangle(25, 315, 150, 25));
        Info.addActionListener(new InfoAction(this));					


        pnlModel.setBackground(Color.lightGray);
        pnlModel.setBorder(border2);       
        pnlModel.setPreferredSize(new Dimension(200, 50));
        pnlModel.setBounds(new Rectangle(0, 105, 200, 50));
        pnlModel.setLayout(new GridLayout (1,2,2,2));
        rbtnEnviromentBounded.setSelected(true);
        rbtnEnviromentToroid.setBounds(0 ,0 ,60 ,20);
        rbtnEnviromentBounded.setBounds(0 ,0 ,90 ,20);
        rbtnEnviromentToroid.setLocation(10 ,20);
        rbtnEnviromentBounded.setLocation(100, 20);
        rbtnEnviromentToroid.setBackground(Color.lightGray);
        rbtnEnviromentBounded.setBackground(Color.lightGray); 
        rbtnEnviromentToroid.addActionListener(new NastavitToroid(this));	
        rbtnEnviromentBounded.addActionListener(new NastavitOhraniceny(this));


        pnlVotrelec.setBackground(Color.lightGray);
        pnlVotrelec.setBorder(border4);
	    pnlVotrelec.setPreferredSize(new Dimension(200, 100));
        pnlVotrelec.setBounds(new Rectangle(0, 160, 200, 60));
        pnlVotrelec.setLayout(new GridLayout (1,2,2,2));



        rbtnEnviroment.add(rbtnEnviromentToroid);
        rbtnEnviroment.add(rbtnEnviromentBounded);
        pnlModel.add(rbtnEnviromentToroid);
        pnlModel.add(rbtnEnviromentBounded);

        pnlVotrelec.add(Stranger);
        pnlVotrelec.add(Odobrat);

		Panel panl1 = new Panel();
		panl1.setLayout(new GridLayout(4,1,10,2));
		panl1.setBackground(Color.lightGray);
		panl1.add(lbRychlost);
		panl1.add(sldRychlost);
		panl1.add(lbPocet);
		panl1.add(sldPocet);
		
		Panel panl2 = new Panel();
		panl2.setLayout(new GridLayout(2,1,10,2));
		panl2.setBackground(Color.lightGray);
		panl2.add(pnlModel);
		panl2.add(pnlVotrelec);

		Panel panl3 = new Panel();
		panl3.setLayout(new GridLayout(6,1,10,2));
		panl3.setBackground(Color.lightGray);
		panl3.add(Control);
		panl3.add(Start);
		panl3.add(Pause);
		panl3.add(Numbers);
		panl3.add(Evolution);

		Panel panl4 = new Panel();
		panl4.setLayout(new GridLayout(6,1,10,2));
		panl4.setBackground(Color.lightGray);
		panl4.add(Breed);
		panl4.add(Scramble);
		panl4.add(Predefined);
		panl4.add(Ranges);
		panl4.add(Log);
		panl4.add(Info);

		Panel east = new Panel();
		east.setLayout(new GridLayout(4,1,10,0));
		east.setBackground(Color.lightGray);
		east.setFont(ButtonFont);
		
		east.add(panl1);
		east.add(panl2);
		east.add(panl3);
		east.add(panl4);

		add("East",east);
//	-----------okraje

		Panel bot_3 = new Panel();
		bot_3.setLayout(new GridLayout(1,1,10,10));
		bot_3.setBackground(Color.lightGray);
		  Panel bot_3in = new Panel();
		  bot_3.add(bot_3in);		
		add("West",bot_3);

		Panel bot_2 = new Panel();
		bot_2.setLayout(new GridLayout(1,1,10,10));
		bot_2.setBackground(Color.lightGray);
		  Panel bot_2in = new Panel();
		  bot_2.add(bot_2in);		
		add("North",bot_2);

//--------------okraje
		Panel status = new Panel();
		status.setLayout(new GridLayout(1,1,10,10));
		Font BoldFont = new Font("TimesRoman",Font.BOLD,12);
		status.setBackground(Color.lightGray);
		status.setFont(BoldFont);
		MainTitle = new Label("Akvrium eFloyov");
		MainTitle.setForeground(Color.black);
		status.add(MainTitle);
		add("South",status);

		appcontext = getAppletContext();
		picture = getImage(getCodeBase(),"Efloys1.gif");


		canvas = new EfloyCanvas(Color.red);
		add("Center",canvas);
		canvas.repaint();
		gra = canvas.GetGra();

		center = new Panel();
		center.setLayout(new GridLayout(2,2));
		center.add(new Button("B1"));
		center.add(new Button("B2"));
		center.add(new Button("B3"));
		center.add(new Button("B4"));

		center1 = new Panel();
		center1.setLayout(new GridLayout(2,2));
		center1.add(new Button("B1a"));
		center1.add(new Button("B2a"));
		center1.add(new Button("B3a"));
		center1.add(new Button("B4a"));

		HistoryData = new Vector();

		resize(680,500); // Velkost okna

		CurrentBehavior = 0;
		First = true;

	}

	public void destroy() {

		deb.dispose();

	}


	public void start()
	{
		if (runner == null)
		{
			runner= new Thread(this);
			runner.start();
			running = true;
			CurrentStep = 0;
			CurrentTotalStep = 0;
			CurrentRandom = 0;
			CurrentGeneration = 0;
		}
	}
	
	public void stop()
	{
		if (runner!=null)
		{
			runner.stop();
			runner=null;
			running = false;
		}
	}


	public void run() {

		if (First) {
			InitParamsExtended();
			GetParameters();
			Restart(false);
			randemize();
			First = false;
		}
	

		while (true) {

			if (First) Restart(false);
			First = false;

			CurrentStep++;
			CurrentTotalStep++;
		 	if (Math.random()< (double) KICK) randemize();
			if (((InEvolution) && (NewGeneration)) || ((InEvolution) &&(CurrentStep > 5000))) {
				StartDate = new Date();
				deb.showMsg("Nov genercia ."+(CurrentGeneration+1)+" zaala o "+StartDate.toLocaleString());
				CreateNewGeneration();
			}
		 	canvas.repaint();
		 	try { Thread.sleep(SLEEP);}
		 	catch (InterruptedException e) {
				showStatus("Thread.sleep InterruptedException "+e.toString());
			}
		}
		


	}


	float GetOneParameter(String name, float def) {

		String s;
		Float temp;
		float FloatPar;

		s=getParameter(name);
		if (s==null)
			FloatPar=def;
		else {
			temp = new Float(s);
			FloatPar = temp.floatValue();
		}

		return FloatPar;

	}


	void GetParameters() {

		String s;
		Float temp;
		int IntPar;
		float FloatPar;

		params[0].value = GetOneParameter("MaxSpeed",5f);
		params[1].value = GetOneParameter("BounceSpeed",0.8f);
		params[2].value = GetOneParameter("ApproachAcceleration",0.3f);
		params[4].value = GetOneParameter("CenterAcceleration",0.1f);
		params[5].value = GetOneParameter("DistBrotherFactor",1f);
		params[6].value = GetOneParameter("DistStrangerFactor",20f);
		params[7].value = GetOneParameter("DistLocalFactor",0f);
		params[8].value = GetOneParameter("CollisionDistance",200f);
		params[9].value = GetOneParameter("CollisionBrotherFactor",-1f);
		params[10].value = GetOneParameter("CollisionStrangerFactor",30f);
		params[11].value = GetOneParameter("CollisionLocalFactor",-40f);

		fixpars[5].value = GetOneParameter("NumberOfNeighbors",2f);
		fixpars[6].value = GetOneParameter("MutationFactor",0.1f);
		fixpars[7].value = GetOneParameter("CrossoverFactor",1f);
		fixpars[8].value = GetOneParameter("energy",10f);
		fixpars[9].value = GetOneParameter("safety",10f);
		fixpars[10].value = GetOneParameter("cooperation",10f);

		envpars[5].value = GetOneParameter("EnergyFactor",1f);
		envpars[6].value = GetOneParameter("SafetyFactor",1f);
		envpars[7].value = GetOneParameter("CooperationFactor",0f);
		envpars[8].value = GetOneParameter("SurviversFactor",0f);
		envpars[12].value = GetOneParameter("PopulationSize",10f);
		envpars[13].value = GetOneParameter("FreeWillFactor",0.05f);
		envpars[14].value = GetOneParameter("LifeSpan",50f);

		NF = (int) envpars[12].value;
		SLEEP = (long) envpars[3].value;
		KICK =  envpars[13].value;

}


	public void randemize()
	{
		int i,j,k,n;

		CurrentRandom++;
		for (k=0;k<Efloys.length;k++) {
			Efloy ng = Efloys[k];
			for (j=0;j<ng.NumberOfNeighbors;j++) {
				n =(int) (Math.random()*(Efloys.length-1));
				ng.neighbors[j] = Efloys[n];
			}
		}
	}


	public void scramble() {

		int i;
			
		for (i=0;i<Efloys.length;i++) {
			Efloys[i].shuffle(false,(float) 0.3);
		}

		GetSumFitness();

		for (i=0;i<Efloys.length;i++) {
			if (Efloys[i].type == 1) {
				Efloys[i].energy = Efloys[i].LifeSpan;
			}
		}

	}



	public void CreateNewGeneration() {

		RecordGeneration();

		CurrentGeneration++;
		PreScale();
		Breed();
		ReleaseStranger();
		NewGeneration = false;
		CurrentStep = 0;
			
		showStatus("Genercia ." + CurrentGeneration);
		MainTitle.setText("Genercia ." + CurrentGeneration);
	}


	public int GetWinner() {

		int i, winner, e;
			
		e = 0;
		winner = 0;

		for (i=0;i<Efloys.length;i++) {
			Efloys[i].GetFitness();
			if (Efloys[i].fitness > e) {
				e = Efloys[i].fitness;
				winner = i;
			}
		}

		return winner;
	}


	public void RecordGeneration() {

		int i, w, fit;
		float SpeedSum, SpeedAvg, AccSum, AccAvg;
		float DllSum, DllAvg, DslSum, DslAvg, DlsSum, DlsAvg;
		float CllSum, CllAvg, CslSum, CslAvg, ClsSum, ClsAvg;
			
		fit = 0;
		w = 0;
		SpeedSum = 0;
		AccSum = 0;
		DllSum = 0;
		DlsSum = 0;
		DslSum = 0;
		CllSum = 0;
		ClsSum = 0;
		CslSum = 0;

		for (i=0;i<Efloys.length;i++) {
			SpeedSum = SpeedSum + Efloys[i].MaxSpeed;
			AccSum = AccSum + Efloys[i].ApproachAcceleration;
			DllSum = DllSum + Efloys[i].DistBrotherFactor;
			DlsSum = DllSum + Efloys[i].DistStrangerFactor;
			DslSum = DllSum + Efloys[i].DistLocalFactor;
			CllSum = CllSum + Efloys[i].CollisionBrotherFactor;
			ClsSum = CllSum + Efloys[i].CollisionStrangerFactor;
			CslSum = CllSum + Efloys[i].CollisionLocalFactor;

			Efloys[i].GetFitness();
			if (Efloys[i].fitness > fit) {
				fit = Efloys[i].fitness;
				w = i;
			}
		}

		SpeedAvg = (float) SpeedSum/Efloys.length;
		AccAvg = (float) AccSum/Efloys.length;
		DllAvg = (float) DllSum/Efloys.length;
		DlsAvg = (float) DlsSum/Efloys.length;
		DslAvg = (float) DslSum/Efloys.length;
		CllAvg = (float) CllSum/Efloys.length;
		ClsAvg = (float) ClsSum/Efloys.length;
		CslAvg = (float) CslSum/Efloys.length;

		Efloys[w].GetFitness();
		FloyGen = new EfloyGeneration(CurrentGeneration, CurrentStep, 0, Efloys[w].id, Efloys[w].chrom, 
			Efloys[w].fitness, Efloys[w].energy, Efloys[w].safety, 
			Efloys[w].cooperation, Efloys[w].MaxSpeed,Efloys[w].ApproachAcceleration,
			AccSum,AccAvg,DllAvg,DlsAvg,DslAvg,CllAvg,ClsAvg,CslAvg);

		HistoryData.addElement(FloyGen);

	}


	void InitParamsLimited() {

		params = new EfloyParam[12];

		params[0]  = new EfloyParam(1f,11f,0.5f,5f,"MaxSpeed",true);
		params[1]  = new EfloyParam(0.2f,2.2f,0.1f,0.8f,"BounceSpeed",true);
		params[2]  = new EfloyParam(0.1f,1.1f,0.05f,0.3f,"ApproachAcceleration",true);
		params[3]  = new EfloyParam(0.1f,1.1f,0.05f,0.3f,"RetreatAcceleration",true);
		params[4]  = new EfloyParam(0f,0.2f,0.01f,0.1f,"CenterAcceleration",true);

		params[5]  = new EfloyParam(0f,10f,0.5f,1f,"DistBrotherFactor",true);
		params[6]  = new EfloyParam(0f,50f,2.5f,20f,"DistStrangerFactor",true);
		params[7]  = new EfloyParam(-50f,50f,0.5f,0f,"DistLocalFactor",true);

		params[8]  = new EfloyParam(0f,500f,25f,200f,"CollisionDistance",true);

		params[9]  = new EfloyParam(-10f,0f,0.5f,-1f,"CollisionBrotherFactor",true);
		params[10] = new EfloyParam(0f,100f,5f,30f,"CollisionStrangerFactor",true);
		params[11] = new EfloyParam(-100f,0f,5f,-40f,"CollisionLocalFactor",true);



		fixpars = new EfloyParam[12];

		fixpars[0] = new EfloyParam(1f,100f,1f,(float) CurrentNum,"id",false);
		fixpars[1] = new EfloyParam(1f,100f,1f,0f,"father",false);
		fixpars[2] = new EfloyParam(1f,100f,1f,0f,"mother",false);
		fixpars[3] = new EfloyParam(0f,10f,1f,0f,"type",false);
		fixpars[4] = new EfloyParam(0f,13f,1f,15f,"color",false);
		fixpars[5] = new EfloyParam(1f,10f,1f,2f,"NumberOfNeighbors",false);
		fixpars[6] = new EfloyParam(0f,0.2f,0.01f,0.1f,"MutationFactor",false);
		fixpars[7] = new EfloyParam(0f,1f,0.1f,1f,"CrossoverFactor",false);

		fixpars[8] = new EfloyParam(0f,100f,10f,10f,"energy",true);
		fixpars[9] = new EfloyParam(0f,100f,10f,10f,"safety",true);
		fixpars[10] = new EfloyParam(0f,100f,10f,10f,"cooperation",true);
		
		fixpars[11] = new EfloyParam(0f,100f,10f,10f,"fitness",true);



		envpars = new EfloyParam[15];

		float h = (float) canvas.size().height;
		float w = (float) canvas.size().width;

		envpars[0] = new EfloyParam(100f,1000f,10f,w,"width",false);
		envpars[1] = new EfloyParam(100f,1000f,10f,h,"height",false);
		envpars[2] = new EfloyParam(1f,10f,1f,4f,"v0",false);
		envpars[3] = new EfloyParam(5f,50f,5f,20f,"sleep",false);
		envpars[4] = new EfloyParam(0f,50f,5f,30f,"margin",false);

		envpars[5] = new EfloyParam(0f,10f,1f,1f,"EnergyFactor",true);
		envpars[6] = new EfloyParam(0f,10f,1f,1f,"SafetyFactor",true);
		envpars[7] = new EfloyParam(0f,10f,1f,0f,"CooperationFactor",true);
		envpars[8] = new EfloyParam(0f,100f,10f,0f,"SurviversFactor",true);

 		envpars[9] = new EfloyParam(-10f,10f,1f,1f,"MaxEnergyDose",true);
		envpars[10] = new EfloyParam(-10f,10f,1f,1f,"MaxSafetyDose",true);
		envpars[11] = new EfloyParam(-10f,10f,1f,1f,"MaxCooperationDose",true);

		envpars[12] = new EfloyParam(5f,50f,5f,10f,"PopulationSize",true);
		envpars[13] = new EfloyParam(0.01f,0.1f,0.01f,0.05f,"FreeWillFactor",true);
		envpars[14] = new EfloyParam(10f,200f,10f,50f,"LifeSpan",true);

	}


	void InitParamsExtended() {

		params = new EfloyParam[12];

		params[0]  = new EfloyParam(1f,11f,0.5f,5f,"MaxSpeed",true);
		params[1]  = new EfloyParam(0.2f,2.2f,0.1f,0.8f,"BounceSpeed",true);
		params[2]  = new EfloyParam(0.1f,2.1f,0.1f,0.3f,"ApproachAcceleration",true);
		params[3]  = new EfloyParam(0.1f,2.1f,0.1f,0.3f,"RetreatAcceleration",true);
		params[4]  = new EfloyParam(0f,0.2f,0.01f,0.1f,"CenterAcceleration",true);

		params[5]  = new EfloyParam(-10f,10f,1f,1f,"DistBrotherFactor",true);
		params[6]  = new EfloyParam(-50f,50f,5f,20f,"DistStrangerFactor",true);
		params[7]  = new EfloyParam(-50f,50f,5f,0f,"DistLocalFactor",true);

		params[8]  = new EfloyParam(0f,500f,25f,200f,"CollisionDistance",true);

		params[9]  = new EfloyParam(-10f,10f,1f,-1f,"CollisionBrotherFactor",true);
		params[10] = new EfloyParam(-100f,100f,10f,30f,"CollisionStrangerFactor",true);
		params[11] = new EfloyParam(-100f,100f,10f,-40f,"CollisionLocalFactor",true);



		fixpars = new EfloyParam[12];

		fixpars[0] = new EfloyParam(1f,100f,1f,(float) CurrentNum,"id",false);
		fixpars[1] = new EfloyParam(1f,100f,1f,0f,"father",false);
		fixpars[2] = new EfloyParam(1f,100f,1f,0f,"mother",false);
		fixpars[3] = new EfloyParam(0f,10f,1f,0f,"type",false);
		fixpars[4] = new EfloyParam(0f,13f,1f,15f,"color",false); // Farba na zaciatku
		fixpars[5] = new EfloyParam(1f,10f,1f,2f,"NumberOfNeighbors",false);
		fixpars[6] = new EfloyParam(0f,0.2f,0.01f,0.1f,"MutationFactor",false);
		fixpars[7] = new EfloyParam(0f,1f,0.1f,1f,"CrossoverFactor",false);

		fixpars[8] = new EfloyParam(0f,100f,10f,10f,"energy",true);
		fixpars[9] = new EfloyParam(0f,100f,10f,10f,"safety",true);
		fixpars[10] = new EfloyParam(0f,100f,10f,10f,"cooperation",true);
		
		fixpars[11] = new EfloyParam(0f,100f,10f,10f,"fitness",true);



		envpars = new EfloyParam[15];

		float h = (float) canvas.size().height;
		float w = (float) canvas.size().width;

		envpars[0] = new EfloyParam(100f,1000f,10f,w,"width",false);
		envpars[1] = new EfloyParam(100f,1000f,10f,h,"height",false);
		envpars[2] = new EfloyParam(1f,10f,1f,4f,"v0",false);
		envpars[3] = new EfloyParam(5f,50f,5f,20f,"sleep",false);
		envpars[4] = new EfloyParam(0f,50f,5f,30f,"margin",false);

		envpars[5] = new EfloyParam(0f,10f,1f,1f,"EnergyFactor",true);
		envpars[6] = new EfloyParam(0f,10f,1f,1f,"SafetyFactor",true);
		envpars[7] = new EfloyParam(0f,10f,1f,0f,"CooperationFactor",true);
		envpars[8] = new EfloyParam(0f,100f,10f,0f,"SurviversFactor",true);

 		envpars[9] = new EfloyParam(0f,20f,1f,10f,"MaxEnergyDose",true);
		envpars[10] = new EfloyParam(0f,20f,1f,10f,"MaxSafetyDose",true);
		envpars[11] = new EfloyParam(0f,20f,1f,10f,"MaxCooperationDose",true);

		envpars[12] = new EfloyParam(5f,50f,5f,10f,"PopulationSize",true);
		envpars[13] = new EfloyParam(0f,0.1f,0.01f,0.05f,"FreeWillFactor",true);
		envpars[14] = new EfloyParam(10f,200f,10f,50f,"LifeSpan",true);

	}


	static String EncodeChrom(EfloyParam pars[]) {

		int i;
		char kar;
		String st;
		StringBuffer sb = new StringBuffer(pars.length);

		for (i=0;i<pars.length;i++) {
			kar = pars[i].EncodeValue();
			sb.append(kar);
		}

		st = sb.toString();
		return st;

	}


	
	static public void reset() {

		NF = 10;
		KICK = (float) 0.05;
		SLEEP = 20;

	}
	

	private int GetFloyNumber(int fid) {

		int i, num;

		num = -1;
		for (i=0;i<Efloys.length;i++)
	 	{
			if (Efloys[i].id == fid)
				num= i;
		}
		return num;

	}

	public void ReleaseStranger() {

		int num;

		num = GetFloyNumber(0);
		Efloys[num].type =1;
		Efloys[num].color = Color.red;
		Efloys[num].energy = Efloys[num].LifeSpan;
		Efloys[num].safety = 10;
		Efloys[num].cooperation = 10;
		Efloys[num].GetFitness();
		Efloys[num].x = canvas.size().width;
		Efloys[num].y = 0;
		Efloys[num].DistLocalFactor = 0;
		Efloys[num].CollisionLocalFactor = -40;
		Efloys[num].CenterAcceleration = 0.1f;

	}



	public void Restart(boolean Reset) {

		int i;
		String st, fx, ev;

		if (Reset) {

			HistoryData.removeAllElements();

			InEvolution = false;
			NewGeneration = false;
			CurrentStep = 0;
			CurrentTotalStep = 0;
			CurrentGeneration = 0;

			ResetPopulation = true;
			stop();
			First = true;
			showStatus("");
			start();
		}

		if (ResetPopulation) {
			Efloys = new Efloy[NF];
			for (i=0;i<Efloys.length;i++) {
				CurrentNum = i;
				st = EncodeChrom(params);
				fx = EncodeChrom(fixpars);
				ev = EncodeChrom(envpars);
				Efloys[i] = new Efloy(params, st, fixpars, fx, envpars, ev);
				Efloys[i].id = i;
				if(Reset) {
							Efloys[i].toroid = false;
							rbtnEnviromentBounded.setSelected(true);
						  }
						
			}
			ResetPopulation = false;
		}

	}


	public void ResizeFrame(Frame frame) {

		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		int w = d.width;
		int h = d.height;
		frame.reshape(0,0,w,h-100);

		frame.show();

	}


	public void CenterFrame(Frame frame) {

		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		int w = d.width;
		int h = d.height;
		int fw = 640;
		int fh = 480;
		int dw = (int) (w - fw)/2;
		int dh = (int) (h - fh)/1;
		frame.move(dw,dh);

	}


	void UpdateFloysParams() {

		int i;
		String st, fx, ev;

		int size = Efloys[0].PopulationSize;

		for (i=0;i<size;i++) {
			Efloys[i].params = params;
			Efloys[i].fixpars = fixpars;
			Efloys[i].envpars = envpars;
			st = EncodeChrom(params);
			fx = EncodeChrom(fixpars);
			ev = EncodeChrom(envpars);
			Efloys[i] = new Efloy(params, st, fixpars, fx, envpars, ev);
			Efloys[i].id = i;
		}
	}


//------------------Akcie-------------------------
  public class OdobratAction extends AbstractAction {						
    
      Efloys aplet;															

    public OdobratAction(Efloys aplet) 										
      {
        super("OdobratAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 							
      {

		int numS;
		int numF;

		numS = GetFloyNumber(0);
		numF = GetFloyNumber(1);
		Efloys[numS].type = Efloys[numF].type;
		Efloys[numS].color = Efloys[numF].color;
		Efloys[numS].energy = Efloys[numF].energy;
		Efloys[numS].safety = Efloys[numF].safety;
		Efloys[numS].cooperation = Efloys[numF].cooperation;
		Efloys[numS].GetFitness();
		Efloys[numS].DistLocalFactor = Efloys[numF].DistLocalFactor;
		Efloys[numS].CollisionLocalFactor = Efloys[numF].CollisionLocalFactor;
		Efloys[numS].CenterAcceleration = Efloys[numF].CenterAcceleration;

      }
   
  }

 public class NastavitToroid extends AbstractAction{
  
     Efloys aplet;															
  	
  public NastavitToroid(Efloys aplet)
    {
     super("EnviromentModelAction");
     this.aplet = aplet;
     	
    }	
  public void actionPerformed(ActionEvent e) 
    {	
		int i;
				for (i=0;i<NF;i++) {
						Efloys[i].toroid = true;
				}
		
    }
  }
  
  public class NastavitOhraniceny extends AbstractAction{
 
     Efloys aplet;															
   	
   public NastavitOhraniceny(Efloys aplet)
    {
     super("EnviromentModelAction");
     this.aplet = aplet;
     	
    }	
   public void actionPerformed(ActionEvent e) 
    {	
		int i;
				for (i=0;i<NF;i++) {
						Efloys[i].toroid = false;
				}
    }
  }  


 public class RychlostAction implements ChangeListener {						
      Efloys aplet;															
     int speed;    
    
    public RychlostAction(Efloys aplet) 									
      {
        super();
        this.aplet = aplet;
      }   	
   	
   	public void stateChanged(ChangeEvent e)
   	  {
   	   speed = ((JSlider)e.getSource()).getValue();
   	   SLEEP = 100 - speed;
   	   aplet.lbRychlost.setText("Rchlos: "+ speed +"%"); 		
   	  }
   }	 

public class StartAction extends AbstractAction {						
    
      Efloys aplet;														
    
    public StartAction(Efloys aplet) 								
      {
        super("StartAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 						
      {		
      		rbtnEnviromentBounded.setSelected(true);
			MainTitle.setText("Akvrium eFloyov");
			deb.clear();
			deb.start();
			NF = 10;
			aplet.sldPocet.setValue(10);
	 	    aplet.sldRychlost.setValue(80);
			InitParamsExtended();
			InEvolution = false;
			NewGeneration = false;
			CurrentStep = 0;
			CurrentTotalStep = 0;
			CurrentGeneration = 0;
			ResetPopulation = true;
			Restart(true);
		}
      }

   public class PocetAction implements ChangeListener {						
     Efloys aplet;															
     int count,i;
    public PocetAction(Efloys aplet) 										
      {
        super();
        this.aplet = aplet;
      }   	
   	
   	public void stateChanged(ChangeEvent e)
   	  {
   	   count = ((JSlider)e.getSource()).getValue();	

			deb.clear();
			deb.start();
			NF=count;
			ResetPopulation = true;
			Restart(false);


	   aplet.lbPocet.setText("Poet jedincov: "+count);   	  
   	  	
   	  }
   }	 



public class ControlAction extends AbstractAction {						
    
      Efloys aplet;														
    
    public ControlAction(Efloys aplet) 									
      {
        super("ControlAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 								
      {

			MainTitle.setForeground(Color.blue);
			String OldTitle = MainTitle.getText();
			MainTitle.setText("Nahrvam vlastnosti, prosm akajte..");
			MainTitle.resize(MainTitle.preferredSize());

			showStatus("Nahrvam nastavenia, prosm akajte..");
			fcommand = new EfloyCommand(Efloys);
			ResizeFrame(fcommand);
			MainTitle.setText(OldTitle);
			MainTitle.setForeground(Color.black);
			Restart(false);

		}
      }

public class PredefinedAction extends AbstractAction {					
    
      Efloys aplet;														
    
    public PredefinedAction(Efloys aplet) 										
      {
        super("PredefinedAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 							
      {

			fpredefined = new EfloyPredefined();
			ResizeFrame(fpredefined);
			aplet.sldPocet.setValue((int)NF);
	 	    aplet.sldRychlost.setValue((int) (100 - SLEEP));

		}
      }

public class LogAction extends AbstractAction {						
    
      Efloys aplet;													
    
    public LogAction(Efloys aplet) 									
      {
        super("LogAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 					
      {

			deb.show();
		}
      }


public class RangesAction extends AbstractAction {						
    
      Efloys aplet;														
    
    public RangesAction(Efloys aplet) 									
      {
        super("RangesAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 									
      {

			if (LimitedRanges) {
				Ranges.setLabel("Limitovan rozsah");
				InitParamsExtended();
				UpdateFloysParams();
				LimitedRanges = false;
			}
			else {
				Ranges.setLabel("Normlny rozsah");
				InitParamsLimited();
				UpdateFloysParams();
				LimitedRanges = true;
			}
		}
      }

public class NumbersAction extends AbstractAction {						
    
      Efloys aplet;														
    
    public NumbersAction(Efloys aplet) 									
      {
        super("NumbersAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 							
      {

			if (DrawNumbers) {
				Numbers.setLabel("Uk sla");
				DrawNumbers = false;
			}
			else {
				Numbers.setLabel("Uk Floyov");
				DrawNumbers = true;
			}
		}
      }


public class StrangerAction extends AbstractAction {							
    
      Efloys aplet;															
    
    public StrangerAction(Efloys aplet) 									
      {
        super("StrangerAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 								
      {

			ReleaseStranger();			
		}
      }


public class EvolutionAction extends AbstractAction {						
    
      Efloys aplet;														
    
    public EvolutionAction(Efloys aplet) 										
      {
        super("EvolutionAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 								
      {

			if (InEvolution) {
				Evolution.setLabel("tart evolcie");
				InEvolution = false;
				NewGeneration = false;
				showStatus("");
			}
			else {
				Evolution.setLabel("Stop evolcie");
				InEvolution = true;
				NewGeneration = true;
				showStatus("");
			}
			
		}
      }

public class BreedAction extends AbstractAction {						
    
      Efloys aplet;														
    
    public BreedAction(Efloys aplet) 								
      {
        super("BreedAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 							
      {

			CreateNewGeneration();
			
		}
      }

public class ScrambleAction extends AbstractAction {						
    
      Efloys aplet;														
    
    public ScrambleAction(Efloys aplet) 										
      {
        super("ScrambleAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 								
      {

			scramble();
			
		}
      }


public class PauseAction extends AbstractAction {						
    
      Efloys aplet;													
    
    public PauseAction(Efloys aplet) 									
      {
        super("PauseAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 								
      {

			if (running) {
				runner.suspend();
				running = false;
				Pause.setLabel("Pokrauj");
			}
			else {
				runner.resume();
				running = true;
				Pause.setLabel("Pause");
			}


			
		}
      }
      
public class InfoAction extends AbstractAction {						
    
      Efloys aplet;														
    
    public InfoAction(Efloys aplet) 										
      {
        super("InfoAction");
        this.aplet = aplet;
      }

    public void actionPerformed(ActionEvent e) 								
      {
			MainTitle.setForeground(Color.blue);
			String OldTitle = MainTitle.getText();
			MainTitle.setText("Nahrvam info, prosm akajte...");
			MainTitle.resize(MainTitle.preferredSize());

			showStatus("Nahrvam info, prosm akajte...");
			finfo = new EfloyInfo(Efloys);
			ResizeFrame(finfo);
			MainTitle.setText(OldTitle);
			MainTitle.setForeground(Color.black);

			
		}
      }      
//------------------------------------------------




	public boolean handleEvent(Event evt) {

		if(evt.id == Event.WINDOW_DESTROY) {
			showStatus("Zatvorenie okna");
			destroy();
			System.exit(0);
		}
		else
		if (evt.id == Event.MOUSE_DOWN) {
			deb.hide();
		}


		return super.handleEvent(evt);
	}




	void SortFloys() {

		int i,j;
		boolean swap;
		int e;
		Efloy etemp;

		for (i=0;i < Efloys.length-1;i++) {
			swap = false;
			for (j=Efloys.length-2;j>=i;j--) {
				Efloys[j].GetFitness();
				Efloys[j+1].GetFitness();
				e = Efloys[j].fitness - Efloys[j+1].fitness;
				if (e < 0) {
					etemp = Efloys[j];
					Efloys[j] = Efloys[j+1];
					Efloys[j+1] = etemp;
					swap = true;
				}
			}
			if (swap == false) {
				break;
			}
		}

	}


	void SortFloys(Efloy[] floys) {

		int i,j;
		boolean swap;
		int e;
		Efloy etemp;

		for (i=0;i < floys.length-1;i++) {
			swap = false;
			for (j=floys.length-2;j>=i;j--) {
				Efloys[j].GetFitness();
				Efloys[j+1].GetFitness();
				e = floys[j].fitness - floys[j+1].fitness;
				if (e < 0) {
					etemp = floys[j];
					floys[j] = floys[j+1];
					floys[j+1] = etemp;
					swap = true;
				}
			}
			if (swap == false) {
				break;
			}
		}

	}


	private long GetSumFitness() {

		int i;
		long sum;
		float eng, saf, avg;
		float facavg, facsaf;;

		eng = 0;
		saf = 0;
		sum = 0;

		for (i=0;i < Efloys.length;i++) {
			eng = eng + (float) Efloys[i].energy;
			saf = saf + (float) Efloys[i].safety;
		}

		avg = 100;
		facavg = eng/Efloys.length/avg;
		facsaf =  saf/eng;

		for (i=0;i < Efloys.length;i++) {
			Efloys[i].energy = (int) (Efloys[i].energy/facavg);
			Efloys[i].safety = (int) (Efloys[i].safety/facavg/facsaf);
			Efloys[i].GetFitness();
			sum = sum + Efloys[i].fitness;
		}

		return sum;

	}

		

	private int GetParentID() {

		int i,j,k,n;
		int rand, partsum;

		i = 0;
		partsum = 0;
		n = Efloys.length;
		rand =(int) (Math.random()*SumFitness);
		int avg = (int) (SumFitness/n);

		j = 0;
		for (i=0;i<Efloys.length;i++) {
			Efloys[i].GetFitness();
			partsum = partsum + (int) Efloys[i].fitness;
			if (partsum >= rand) {
				j = 1;
				break;
			}
		}

		
		if (j == 0) {
			i = Efloys.length-1;
		}


		return Efloys[i].id;	

	}


	private Efloy Mate() {

		int MomID, DadID;
		Efloy Mom, Dad , Kid;
		String KidChrom, fx, ev;
		
		MomID = GetParentID();
		DadID = GetParentID();
		Mom = Efloys[GetFloyNumber(MomID)];
		Dad = Efloys[GetFloyNumber(DadID)];
		
		if (Mom.type == 1) {
			while (Mom.type == 1) {
				MomID = GetParentID();
				Mom = Efloys[GetFloyNumber(MomID)];
				deb.showMsg("Opakujem matku = "+MomID);
			}
		}

		if (Dad.type == 1) {
			while (Dad.type == 1) {
				DadID = GetParentID();
				Dad = Efloys[GetFloyNumber(DadID)];
				deb.showMsg("Opakujem otca = "+DadID);
			}
		}

		KidChrom = Dad.CrossOver(Mom.chrom);

		fx = EncodeChrom(fixpars);
		ev = EncodeChrom(envpars);
		Kid = new Efloy(params, KidChrom, fixpars, fx, envpars, ev);
		Kid.chrom = Kid.mutate();
		if (Dad.color == Color.red)
			Kid.AssignColor(Mom.GetColorNumber());
		else
			Kid.AssignColor(Dad.GetColorNumber());
		Kid.energy = (int) ((Dad.energy + Mom.energy)/2);
		Kid.safety = (int) ((Dad.safety + Mom.safety)/2);
		Kid.cooperation = (int) ((Dad.cooperation + Mom.cooperation)/2);
		Kid.GetFitness();

		Kid.x = 10;
		Kid.y = 10;
		canvas.repaint();


		return Kid;

	}


	private void Breed() {

		int i,n;

		SumFitness = GetSumFitness();
		NewFloys = new Efloy[Efloys.length];

		for (i=0;i<Efloys.length;i++) {
			NewFloys[i] = Mate();
			NewFloys[i].id = i;
		}


		if (Efloys[0].SurviversFactor > 0) {
			SortFloys(Efloys);
			SortFloys(NewFloys);
			n = (int) (Efloys.length*Efloys[0].SurviversFactor/100);
			for (i=0;i<Efloys.length;i++) {
				if (i > (n-1))
					Efloys[i] = NewFloys[i-n];
			}
		}
		else {
			for (i=0;i<Efloys.length;i++)
					Efloys[i] = NewFloys[i];
		}

	}


	static boolean Flip(float ref) {

		float rand = (float) Math.random();
		if (rand < ref)
			return true;
		else
			return false;

	}



	private void PreScale() {
		
	
		int i;
		double tmin = 10e35;
		double tmax = -10e35;
		double tsum = 0;

		int size = Efloys[0].PopulationSize;
		for (i=0;i<size;i++) {
			Efloys[i].GetFitness();
			if (Efloys[i].fitness < tmin)
				tmin = Efloys[i].fitness;
			if (Efloys[i].fitness > tmax)
				tmax = Efloys[i].fitness;
			tsum = tsum + Efloys[i].fitness;
		}

		double tavg = tsum/size;
		double temp = (tmax+tmin)/2;
		double factor = 1.80; 
		double a_coeff = 1;
		double b_coeff = 0;
		double delta;
		

		if (factor > 1) {
				if (tmin > (factor * tavg - tmax) / (factor - 1)) {
					delta = tmax - tavg;
					if (delta != 0) {
						a_coeff = (factor - 1) * tavg / delta;
						b_coeff = tavg * (tmax - factor * tavg) / delta;
					}
				}
		}
		else {
				delta = tavg - tmin;
				if (delta != 0) {
					a_coeff = tavg / delta;
					b_coeff = -tmin * tavg / delta;
				}
		}


		for (i=0;i<size;i++)
			Efloys[i].fitness = (int) (Efloys[i].fitness*a_coeff + b_coeff);

		
	}
}
	



